/*
 *  This program is for Pharlap target only (not djgpp).
 *
 *  This program should be linked with -offset 1000h to
 *  trap the NULL pointer reference in the 2nd statement in main()
 *  This makes it impossible to run it under Windows though
 */

#if defined (__BORLANDC__) || (__MSC32__)
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <winnt.h>
#include <excpt.h>
#include <pharlap.h>
#include <exc.h>

#ifdef __BORLANDC__      /* use Borland's intrinsic functions */
#define memcpy  __memcpy__
#endif

static int ExcFilter (int code, struct _EXCEPTION_POINTERS *exc)
{
  static char pageBuf[4096];

  printf ("ExcFilter(%08X,%08X)\n",code,exc);   // !! test

  if (code == EXCEPTION_ACCESS_VIOLATION)
     return (EXCEPTION_EXECUTE_HANDLER);

  if (code == EXCEPTION_IN_PAGE_ERROR)
  {
    puts ("Page fault. Paging in fresh page");
    exc->ContextRecord->Edi = (DWORD) &pageBuf;  /* assume edi is wrong !! */
    return (EXCEPTION_CONTINUE_EXECUTION);
  }
//return (EXCEPTION_CONTINUE_SEARCH);
  return (EXCEPTION_EXECUTE_HANDLER);
}

void * memcpy_safe (void *dst, void *src, int len)
{
  try
  {
    return memcpy (dst,src,len);
  }
//except (ExcFilter(GetExceptionCode(),GetExceptionInformation()))
  except (0)
  {
    if (dst == NULL)
         puts ("copy to NULL in memcpy()");
    else puts ("exception in memcpy()");
    return (NULL);
  }
}

int main (void)
{
  printf ("memcpy_safe() = %08Xh\n\n", memcpy_safe("destin","source", 6  ));
  printf ("memcpy_safe() = %08Xh\n\n", memcpy_safe( NULL,   "data",   100));
  printf ("memcpy_safe() = %08Xh\n\n", memcpy_safe("data",  (void*)-1,4  ));
  return (0);
}

#else  /* !(BCC32 || MSC32) */

#include <stdio.h>
int main (void)
{
  puts ("try/except block only works with BCC32 (and MSC32 ?)");
  return (1);
}
#endif

