#
# Makefile (Borland make) for HighC/Pharlap exception handler demos
# MetaWare High C 3.0+
#
# The LIBPATH environment variable must be set to point to
# the libraries, e.g. "set libpath=c:\dosx\lib;d:\hc\flat"
#

.AUTODEPEND

CC = hc386 -g -I..
AS = tasm /mx /t /l /dHC386_31

#
# Include path for 16-bit test programs.
# Change DOSX path to suite
#
INC_BCC16 = -I..\src -Ie:\dosx\inc

LIBS = ..\lib\exc_hc.lib

LINK = -lib hc386, hc387, hcna, dosx32, $(LIBS)               \
       -nostub -offset 1000h -twocase -unprivileged -symbols \
       -purge none * -mapnames 30 -mapwidth 132 -fullseg     \
       -publist both

all  : demo_1.exp demo_2.exp demo_3.exp demo_4.exp demo_5.exp  \
       demo_6.exp demo_7.exp demo_8.rex demo_9.exp rm_test.exp \
       exp_dmp.exp descr.exp demangle.exp


.asm.obj:
   $(AS) $*.asm

.c.obj:
   $(CC) -c {$*.c }

.cc.obj:
   $(CC) -c {$*.cc }

demangle.obj: ..\src\demangle.c
   $(CC) -c -DDEMANGLE_TEST $?

trace.obj: ..\src\trace.c
   $(CC) -c -DTEST $?


demo_1.exp: demo_1.obj $(LIBS)
    386link demo_1 @&&|
            $(LINK) -pack
|

demo_2.exp: demo_2.obj $(LIBS)
    386link demo_2 @&&|
            $(LINK) -pack
|

demo_3.exp: demo_3.obj $(LIBS)
    386link demo_3 @&&|
            $(LINK) -pack
|

demo_4.exp: demo_4.obj $(LIBS)
    386link demo_4 @&&|
            $(LINK) -pack
|

demo_5.exp: demo_5.obj $(LIBS)
    386link demo_5 @&&|
            $(LINK) -pack
|

demo_6.exp: demo_6.obj $(LIBS)
    386link demo_6 @&&|
            $(LINK) -pack
|

demo_7.exp: demo_7.obj $(LIBS)
    386link demo_7 @&&|
            $(LINK) -pack -symfile $*.sym
|

demo_8.rex: demo_8.obj $(LIBS)
    386link demo_8 @&&|
            $(LINK) -maxdata 0 -relexe $*.rex
|

demo_9.exp: demo_9.obj $(LIBS)
    386link demo_9 @&&|
             $(LINK) -pack -mapnames 80 -lib hcc386
|

rm_test.exp: rm_test.obj $(LIBS)
    386link rm_test @&&|
            $(LINK) -pack
|


exp_dmp.exe: ..\src\trace.c ..\src\pharlap\cview.c ..\src\demangle.c \
             ..\src\pharlap\pharlap.c
     bcc.exe -DTEST @&&|
       $(INC_BCC16) -e$< $?
|

exp_dmp.exp: trace.obj $(LIBS)
     hc386 -DTEST -c -g $?
     386link trace -exe $< -nostub -sym -lib hc386,hc387,hcna,dosx32,$(LIBS) -map $*.map

descr.exp: descr.obj $(LIBS)
     386link $*.obj -nostub -sym -offset 1000h -lib hc386,hc387,dosx32,$(LIBS) -map $*.map

demangle.exp: demangle.obj
     386link $*.obj -nostub -nosym -lib hc386,hc387

demangle.exe: ..\src\demangle.c
     bcc.exe -DDEMANGLE_TEST $(INC_BCC16) $?

clean:
     del *.obj
     del *.exp
     del *.map
     del *.lst

