
#if !defined(__DJGPP__)
#error This file is for djgpp only
#endif

#include <stdio.h>
#include <malloc.h>
#include <string.h>

#define __EXC_INTERNAL
#include "../../exc.h"
#include "../trace.h"

static SYM_ENTRY *f_symtab;
static char      *f_string_table;

ULONG GetAoutSymbols (int fd, long ofs)
{
  GNU_AOUT f_fh;
  ULONG    stringsize;
  int      nsyms, i;

  lseek (fd, ofs, SEEK_SET);
  read (fd, &f_fh, sizeof(f_fh));

  lseek (fd, ofs + sizeof(f_fh) + f_fh.tsize + f_fh.dsize +
         f_fh.txrel + f_fh.dtrel, SEEK_SET);

  f_symtab = malloc (f_fh.symsize);
  read (fd, f_symtab, f_fh.symsize);
  read (fd, &stringsize, sizeof(stringsize));

  f_string_table = calloc (stringsize,1);
  read (fd, f_string_table+4, stringsize-4);

  for (i = nsyms = 0; i < f_fh.symsize/sizeof(SYM_ENTRY); i++)
  {
    char *cp;
    char *symn = f_string_table + f_symtab[i].string_off;

    switch (f_symtab[i].type & ~N_EXT)
    {
      case N_TEXT:
           cp = symn + strlen(symn) - 2;
           if (!strncmp(symn,"___gnu", 6) ||
               !strcmp(cp,"d.")           || /* as in gcc_compiled. */
               !strcmp(cp,".o"))
              break;
           /* fall-through */
      case N_DATA:
      case N_ABS:
      case N_BSS:
      case N_FN:
      case N_SETV:
      case N_SETA:
      case N_SETT:
      case N_SETD:
      case N_SETB:
      case N_INDR:
           if (!AddAddrSymbol(symn, f_symtab[i].val, 0))
              goto add_fail;
           nsyms++;
           break;
    }
  }

add_fail:
  free (f_string_table);
  free (f_symtab);
  return (nsyms);
}
