#include <string.h>
#include <malloc.h>

/* r-mode TEST program
 */
#if (defined(__SMALL__) && !defined(DOS386)) || defined(__LARGE__)
  #define FARPTR char far*
  #include "trace.h"
  #include <plexp.h>
#else
  #define __EXC_INTERNAL
  #include "exc.h"
#endif

#include "trace.h"

/*
 *  Convert a pascal-type string to a C-string
 */
static char * PasStr (char *s)
{
  static char buf[80];
  int    len = (int)*s++;

  len = MIN (len, sizeof(buf)-1);
  strncpy (buf, s, len);
  buf[len] = '\0';
  return (buf);
}

/*
 *  Get all Pharlap style debug-symbols (selectors and publics)
 */
ULONG GetPharLapSymbols (char *buf, SymHeader *sh)
{
  char    *segSym    = buf;
  char    *segSymEnd = segSym + sh->segSymSize;
  char    *pubSym    = segSymEnd;
  char    *pubSymEnd = pubSym + sh->pubSymSize;
  ULONG    nsyms     = 0;

  while (segSym < segSymEnd)
  {
    char  *name;
    ULONG  ofs, limit;
    USHORT sel;

    name  = PasStr (segSym);   segSym += *segSym + 1;
    ofs   = *(ULONG *) segSym; segSym += sizeof(ULONG);
    limit = *(ULONG *) segSym; segSym += sizeof(ULONG);
    sel   = *(USHORT*) segSym; segSym += sizeof(USHORT);

    if (!AddSegSymbol(name, ofs, sel, limit))
       break;
    segSym += sizeof(USHORT);  /* skip flag */
  }

  while (pubSym < pubSymEnd)
  {
    char  *name;
    ULONG  ofs;
    USHORT idx;   /* selector index */
    USHORT sel;   /* selector for ofs */

    name = PasStr (pubSym);   pubSym += *pubSym + 1;
    ofs  = *(ULONG *) pubSym; pubSym += sizeof(ULONG);
    idx  = *(USHORT*) pubSym; pubSym += sizeof(USHORT);
    sel  = GetSelectorVal (idx);

    if (!AddAddrSymbol(name, ofs, sel))
       break;
    nsyms++;
  }
  return (nsyms);
}
